#include <cctype>
#include <cstddef>
#include <cstring>
#include <string>
#include <iostream>

#include "config.h"

static float get_price(std::string& str)
{
    
    float price = 0;
    const char* str_c = str.c_str();
    char* next;

    for (size_t i = 0; i != str.size(); i++)
    {
        price = std::strtof(str_c + i, &next);
        if (next == NULL)
            break;
        if (std::strncmp(next, "€", 3) == 0)
        {
            str.erase(i, next - (str_c + i) + 3);
            return price;
        }
    }
    return 0;
}

static int get_quantity(std::string& str)
{
    unsigned int quantity = 0;
    size_t len = 0, i;

    for (i = 0; i != str.size(); i++)
    {
        if (!std::isdigit(str[i]))
        {
            if (quantity != 0)
                break;
            continue;
        }
        quantity = quantity * 10 + str[i] - '0';
        len++;
    }
    str.erase(i - len, len);
    return quantity;
}

int get_article_data(std::string& str, unsigned int& quantity, float& price)
{
    price = get_price(str);
    quantity = get_quantity(str);

    return 0;
}

std::string get_token(char** av, char** env)
{
    if (av[1] != NULL)
        return av[1];
    for (size_t i = 0; env[i] != NULL; ++i)
    {
        if (std::strncmp("BOT_TOKEN", env[i], 9) == 0)
            return env[i] + 10;
    }
    return BOT_TOKEN;
}